﻿using Abp.AutoMapper;
using BCS.BMC.BMC.FirebaseCloudMessages;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BCS.BMC.FirebaseCloudMessaging.Dto
{
    [AutoMapTo(typeof (FirebaseCloudMessageDetails))]
    public class NotificationModel
    {
        //[JsonProperty("deviceId")]
        //public string DeviceId { get; set; }
        //[JsonProperty("isAndroidDevice")]
        //public bool IsAndroidDevice { get; set; }
        public string Id { get; set; }
        [JsonProperty("title")]
        public string Title { get; set; }
        [JsonProperty("body")]
        public string Body { get; set; }
        public int UserId { get; set; }
        public string FcmToken { get; set; }
        public string SenderImageurl { get; set; }
        public string SenderName { get; set; }
        public DateTime? MessageSentDateTime { get; set; }
        public bool Status { get; set; }
        public string Message { get; set; }
    }

    public class GoogleNotification
    {
        public class DataPayload
        {
            [JsonProperty("title")]
            public string Title { get; set; }
            [JsonProperty("body")]
            public string Body { get; set; }
        }
        [JsonProperty("priority")]
        public string Priority { get; set; } = "high";
        [JsonProperty("data")]
        public DataPayload Data { get; set; }
        [JsonProperty("notification")]
        public DataPayload Notification { get; set; }
    }
}
