using System.Threading.Tasks;
using Abp.Application.Services;
using Abp.Application.Services.Dto;
using BCS.BMC.Roles.Dto;
using BCS.BMC.Users.Dto;

namespace BCS.BMC.Users
{
    public interface IUserAppService : IAsyncCrudAppService<UserDto, long, PagedUserResultRequestDto, CreateUserDto, UserDto>
    {
        Task DeActivate(EntityDto<long> user);
        Task Activate(EntityDto<long> user);
        Task<ListResultDto<RoleDto>> GetRoles();
        Task ChangeLanguage(ChangeUserLanguageDto input);

        Task<bool> ChangePassword(ChangePasswordDto input);
    }
}
